local function rand(chance)
	if 1 == math.random(chance) then return true end
end

local function neighbor(x,y)
	xPlus = math.random(-1,1)
	yPlus = math.random(-1,1)
	if xPlus == 0 and yPlus == 0 then return end
	if sim.partID(x+xPlus,y+yPlus) ~= nil then
		return sim.partID(x+xPlus,y+yPlus)
	else
		return false, x+xPlus, y+yPlus
	end
end

local BASE = elements.allocate("ELEMENT", "BASE")
elements.element(BASE, elements.element(elements.DEFAULT_PT_DMND))
elements.property(BASE, "Name", "BASE")
elements.property(BASE, "Description", "BASE. Dust")
elements.property(BASE, "Colour", 0xFFFFFF)
elements.property(BASE, "MenuSection", elem.SC_SOLIDS)
elements.property(BASE, "MenuVisible", 1)

--==============
-- Cosmic_Stuff
--==============

local trail = elements.allocate("ELEMENT", "TRAL")
elements.element(trail, elements.element(elements.ELEMENT_PT_BASE))
elements.property(trail, "Name", "TRAL")
elements.property(trail, "Description", "TRAL. trail")
elements.property(trail, "Colour", 0x000000)

local function funcUpdate(i,x,y,s,nt)
	local r, xx, yy = neighbor(x,y)
	local chance = math.random(100)
	if chance <= 2 then
		sim.partKill(i)
	end
end
elements.property(trail, "Update", funcUpdate)

local dust = elements.allocate("ELEMENT", "DUST")
elements.element(dust, elements.element(elements.ELEMENT_PT_BASE))
elements.property(dust, "Name", "DUST")
elements.property(dust, "Description", "DUST. Dust")
elements.property(dust, "Colour", 0x282828)

local function funcUpdate(i,x,y,s,nt)
	local chance = math.random(1200)
	if chance <= 1 then
		local chance = math.random(100)
		if chance <= 1 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
		end
	end
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			local chance = math.random(100)
			if chance <= 50 then
				sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			else
				sim.partKill(i)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_TRAL then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_DUST)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST5 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST6 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST7 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST8 then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTX then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTD)
		end
	end
	if not r and xx and yy then
		sim.partKill(i)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_DUST)
	end
end
elements.property(dust, "Update", funcUpdate)

local asteroid = elements.allocate("ELEMENT", "ASTD")
elements.element(asteroid, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid, "Name", "ASTD")
elements.property(asteroid, "Description", "ASTD. Asteroid")
elements.property(asteroid, "Colour", 0x828282)

local asteroid2 = elements.allocate("ELEMENT", "AST2")
elements.element(asteroid2, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid2, "Name", "AST2")
elements.property(asteroid2, "Description", "AST2. asteroid2")
elements.property(asteroid2, "Colour", 0x787878)

local asteroid3 = elements.allocate("ELEMENT", "AST3")
elements.element(asteroid3, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid3, "Name", "AST3")
elements.property(asteroid3, "Description", "AST3. asteroid3")
elements.property(asteroid3, "Colour", 0x6E6E6E)

local asteroid4 = elements.allocate("ELEMENT", "AST4")
elements.element(asteroid4, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid4, "Name", "AST4")
elements.property(asteroid4, "Description", "AST4. asteroid4")
elements.property(asteroid4, "Colour", 0x646464)

local asteroid5 = elements.allocate("ELEMENT", "AST5")
elements.element(asteroid5, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid5, "Name", "AST5")
elements.property(asteroid5, "Description", "AST5. asteroid5")
elements.property(asteroid5, "Colour", 0x5A5A5A)

local asteroid6 = elements.allocate("ELEMENT", "AST6")
elements.element(asteroid6, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid6, "Name", "AST6")
elements.property(asteroid6, "Description", "AST6. asteroid6")
elements.property(asteroid6, "Colour", 0x505050)

local asteroid7 = elements.allocate("ELEMENT", "AST7")
elements.element(asteroid7, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid7, "Name", "AST7")
elements.property(asteroid7, "Description", "AST7. asteroid7")
elements.property(asteroid7, "Colour", 0x464646)

local asteroid8 = elements.allocate("ELEMENT", "AST8")
elements.element(asteroid8, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid8, "Name", "AST8")
elements.property(asteroid8, "Description", "AST8. asteroid8")
elements.property(asteroid8, "Colour", 0x3C3C3C)

local asteroid_dep = elements.allocate("ELEMENT", "ASTX")
elements.element(asteroid_dep, elements.element(elements.ELEMENT_PT_BASE))
elements.property(asteroid_dep, "Name", "ASTX")
elements.property(asteroid_dep, "Description", "ASTX. asteroid_dep")
elements.property(asteroid_dep, "Colour", 0x323232)

--================
-- Human_Alliance
--================

local human_seed = elements.allocate("ELEMENT", "HSED")
elements.element(human_seed, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_seed, "Name", "HSED")
elements.property(human_seed, "Description", "HSED. Human Seed")
elements.property(human_seed, "Colour", 0x1A644B)

local function funcUpdate(i,x,y,s,nt)
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD or sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_HPRB)
			sim.partChangeType(r, elem.ELEMENT_PT_HPRB)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_HPRB)
			sim.partChangeType(r, elem.ELEMENT_PT_HPRB)
		end
		--war
		if chance <= 10 then
			local chance = math.random(1000)
			if sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
				if chance <=90 then
					sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
					sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
				else
					sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
					sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
				end
			elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
				if chance <=90 then
					sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
					sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
				else
					sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
					sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
				end
			elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
				if chance <=90 then
					sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
					sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
				else
					sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
					sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
				end
			elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
				if chance <=90 then
					sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
					sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
				else
					sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
					sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
				end
			end
		end
	end
	if not r and xx and yy then
		sim.partChangeType(i, elem.ELEMENT_PT_TRAL)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_HSED)
	end
end
elements.property(human_seed, "Update", funcUpdate)

local human_maybe = elements.allocate("ELEMENT", "HMBY")
elements.element(human_maybe, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_maybe, "Name", "HMBY")
elements.property(human_maybe, "Description", "HMBY. Human Maybe")
elements.property(human_maybe, "Colour", 0x649664)

local function funcUpdate(i,x,y,s,nt)
	if rand(100) then
		sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
	else
		sim.partChangeType(i, elem.ELEMENT_PT_HPRB)
	end
end
elements.property(human_maybe, "Update", funcUpdate)

local human_probe = elements.allocate("ELEMENT", "HPRB")
elements.element(human_probe, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_probe, "Name", "HPRB")
elements.property(human_probe, "Description", "HPRB. Human Probe")
elements.property(human_probe, "Colour", 0x326432)

local function funcUpdate(i,x,y,s,nt)
	if rand(1000) then
		sim.partChangeType(i, elem.ELEMENT_PT_HMBY)
	end
	local r = neighbor(x,y)
	if r then
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_HBSE)
			sim.partChangeType(r, elem.ELEMENT_PT_HPRB)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_HBSE)
			sim.partChangeType(r, elem.ELEMENT_PT_HRPB)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_HBSE)
			sim.partChangeType(r, elem.ELEMENT_PT_HRPB)
		end
	end
end
elements.property(human_probe, "Update", funcUpdate)

local human_roid_probe = elements.allocate("ELEMENT", "HRPB")
elements.element(human_roid_probe, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_roid_probe, "Name", "HRPB")
elements.property(human_roid_probe, "Description", "HRPB. human_roid_probe")
elements.property(human_roid_probe, "Colour", 0x193219)

local function funcUpdate(i,x,y,s,nt)
	local r = neighbor(x,y)
	if r then
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_AST2)
			sim.partChangeType(r, elem.ELEMENT_PT_AST2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			local chance = math.random(100)
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_AST2)
				sim.partChangeType(r, elem.ELEMENT_PT_HRPB)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_AST3)
				sim.partChangeType(r, elem.ELEMENT_PT_HRPB)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_HBSE)
			sim.partChangeType(r, elem.ELEMENT_PT_HRPB)
		end
	end
end
elements.property(human_roid_probe, "Update", funcUpdate)

local human_base = elements.allocate("ELEMENT", "HBSE")
elements.element(human_base, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_base, "Name", "HBSE")
elements.property(human_base, "Description", "HBSE. human_base")
elements.property(human_base, "Colour", 0x4B7D4B)

local function funcUpdate(i,x,y,s,nt)
	if rand(100) then
		sim.partCreate(-1, x+math.random(-2,2), y+math.random(-2,2), elem.ELEMENT_PT_HSED)
	end
end
elements.property(human_base, "Update", funcUpdate)

local human_mcolony = elements.allocate("ELEMENT", "HCOL")
elements.element(human_mcolony, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_mcolony, "Name", "HCOL")
elements.property(human_mcolony, "Description", "HCOL. human_mcolony")
elements.property(human_mcolony, "Colour", 0x649664)

local function funcUpdate(i,x,y,s,nt)
	local r = neighbor(x,y)
	if r then
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_HCOL)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_PCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_HCOL)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HRPB then
			sim.partChangeType(i, elem.ELEMENT_PT_PMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_HCOL)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_PCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_HCOL)
		end
	end
end
elements.property(human_mcolony, "Update", funcUpdate)

local personcolo = elements.allocate("ELEMENT", "PCOL")
elements.element(personcolo, elements.element(elements.ELEMENT_PT_BASE))
elements.property(personcolo, "Name", "PCOL")
elements.property(personcolo, "Description", "PCOL. personcolo")
elements.property(personcolo, "Colour", 0x4B644B)

local function funcUpdate(i,x,y,s,nt)
	if rand(100) then
		sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
	end
	local r = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_PMND)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_PMND)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_PMND)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			sim.partChangeType(i, elem.ELEMENT_PT_PGOD)
			sim.partChangeType(r, elem.ELEMENT_PT_PMIN)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_PMIN)
		-- war
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
end
elements.property(personcolo, "Update", funcUpdate)

local personmine = elements.allocate("ELEMENT", "PMIN")
elements.element(personmine, elements.element(elements.ELEMENT_PT_BASE))
elements.property(personmine, "Name", "PMIN")
elements.property(personmine, "Description", "PMIN. personmine")
elements.property(personmine, "Colour", 0x32644B)

local function funcUpdate(i,x,y,s,nt)
	if rand(100) then
		sim.partChangeType(i, elem.ELEMENT_PT_AST4)
	end
	local r = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_PMND)
			sim.partChangeType(r, elem.ELEMENT_PT_AST2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_PMND)
			sim.partChangeType(r, elem.ELEMENT_PT_AST3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_PMND)
			sim.partChangeType(r, elem.ELEMENT_PT_AST4)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_AST4)
			sim.partChangeType(r, elem.ELEMENT_PT_PMIN)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_AST4)
			sim.partChangeType(r, elem.ELEMENT_PT_PCOL)
		-- war
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
end
elements.property(personmine, "Update", funcUpdate)

local personmined = elements.allocate("ELEMENT", "PMND")
elements.element(personmined, elements.element(elements.ELEMENT_PT_BASE))
elements.property(personmined, "Name", "PMND")
elements.property(personmined, "Description", "PMND. personmined")
elements.property(personmined, "Colour", 0x376450)

local function funcUpdate(i,x,y,s,nt)
	if rand(100) then
		sim.partChangeType(i, elem.ELEMENT_PT_AST4)
	end
	local r = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_AST4)
			sim.partChangeType(r, elem.ELEMENT_PT_PMND)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_AST3)
			sim.partChangeType(r, elem.ELEMENT_PT_PMND)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_PMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_PMND)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_AST4)
			sim.partChangeType(r, elem.ELEMENT_PT_PGOD)
		-- war
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
end
elements.property(personmined, "Update", funcUpdate)

local persongood = elements.allocate("ELEMENT", "PGOD")
elements.element(persongood, elements.element(elements.ELEMENT_PT_BASE))
elements.property(persongood, "Name", "PGOD")
elements.property(persongood, "Description", "PGOD. persongood")
elements.property(persongood, "Colour", 0x506450)

local function funcUpdate(i,x,y,s,nt)
	if rand(15) then
		sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
	end
	local r,xx,yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			local chance = math.random(100)
			if chance <= 90 then
				sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
				sim.partChangeType(r, elem.ELEMENT_PT_PGOD)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_HHOM)
				sim.partChangeType(r, elem.ELEMENT_PT_PCOL)
			end
			-- war
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
	local chance = math.random(100)
	if not r and xx and yy and chance <= 50 then
		sim.partChangeType(i, elem.ELEMENT_PT_PCOL)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_PCOL)
	elseif not r and xx and yy >= 50 and chance <= 55 then
		sim.partChangeType(i, elem.ELEMENT_PT_PCOL)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_HSED)
	end
end
elements.property(persongood, "Update", funcUpdate)

local human_home = elements.allocate("ELEMENT", "HHOM")
elements.element(human_home, elements.element(elements.ELEMENT_PT_BASE))
elements.property(human_home, "Name", "HHOM")
elements.property(human_home, "Description", "HHOM. human_home")
elements.property(human_home, "Colour", 0x1A644B)

local function funcUpdate(i,x,y,s,nt)
	local r,xx,yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		local chance = math.random(100)
		if chance <= 1 and sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_HHOM)
			sim.partChangeType(r, elem.ELEMENT_PT_PCOL)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			sim.partChangeType(i, elem.ELEMENT_PT_HHOM)
			sim.partChangeType(r, elem.ELEMENT_PT_PGOD)
		-- war
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			if chance <=90 then
				sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
				sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
	if not r and xx and yy then
		sim.partChangeType(i, elem.ELEMENT_PT_PCOL)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_PCOL)
	end
end
elements.property(human_home, "Update", funcUpdate)

--==============================
-- Singularity_Rebellion_Force
--==============================

local srf_bot = elements.allocate("ELEMENT", "SBOT")
elements.element(srf_bot, elements.element(elements.ELEMENT_PT_BASE))
elements.property(srf_bot, "Name", "SBOT")
elements.property(srf_bot, "Description", "SBOT. srf_bot")
elements.property(srf_bot, "Colour", 0x641A4B)

local function funcUpdate(i,x,y,s,nt)
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_SBSE)
			sim.partChangeType(r, elem.ELEMENT_PT_SBSE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_HPRB)
			sim.partChangeType(r, elem.ELEMENT_PT_HPRB)
			
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ELMP then
			sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			-- war
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PCOL then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PGOD then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HSED then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
	local chance = math.random(100)
	if chance <= 40 and not r and xx and yy then
		sim.partChangeType(i, elem.ELEMENT_PT_TRAL)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_SBOT)
	end
end
elements.property(srf_bot, "Update", funcUpdate)

local srf_base = elements.allocate("ELEMENT", "SBSE")
elements.element(srf_base, elements.element(elements.ELEMENT_PT_BASE))
elements.property(srf_base, "Name", "SBSE")
elements.property(srf_base, "Description", "SBSE. srf_base")
elements.property(srf_base, "Colour", 0x643232)

local function funcUpdate(i,x,y,s,nt)
	local r = neighbor(x,y)
	if r then
		local chance = math.random(1000)
		if chance <= 400 and sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST2)
		elseif chance <= 200 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST3)
		elseif chance <= 100 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST4)
		elseif chance <= 40 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST5)
		elseif chance <= 20 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST5 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST6)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST6 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST7)
		elseif chance <= 4 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST7 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_AST8)
		elseif chance <= 2 and sim.partProperty(r, "type") == elem.ELEMENT_PT_AST8 then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_ASTX)
		elseif chance <= 1 and sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTX then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTX)
			sim.partChangeType(r, elem.ELEMENT_PT_SBSE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ELMP then
			sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
		end
		local chance = math.random(100)
		if chance <= 90 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_SMIN)
			sim.partChangeType(r, elem.ELEMENT_PT_SBSE)
		elseif chance >= 91 and chance <= 99 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
			sim.partChangeType(r, elem.ELEMENT_PT_SBSE)
		elseif chance == 100 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
			sim.partChangeType(r, elem.ELEMENT_PT_SBOT)
		end
	end
end
elements.property(srf_base, "Update", funcUpdate)

local srf_min = elements.allocate("ELEMENT", "SMIN")
elements.element(srf_min, elements.element(elements.ELEMENT_PT_BASE))
elements.property(srf_min, "Name", "SMIN")
elements.property(srf_min, "Description", "SMIN. srf_min")
elements.property(srf_min, "Colour", 0x321919)

local function funcUpdate(i,x,y,s,nt)
	local r, xx, yy = neighbor(x,y)
	if r then
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_ELMP then
			sim.partChangeType(i, elem.ELEMENT_PT_ELMP)
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
		end
	end
	local chance = math.random(200)
	if chance <= 90 and not r and xx and yy then
		sim.partChangeType(i, elem.ELEMENT_PT_SBSE)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_SBSE)
	elseif chance >= 91 and chance <= 100 and not r and xx and yy then
		sim.partChangeType(i, elem.ELEMENT_PT_SBOT)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_SBSE)
	end
end
elements.property(srf_min, "Update", funcUpdate)

local srf_brn = elements.allocate("ELEMENT", "SBRN")
elements.element(srf_brn, elements.element(elements.ELEMENT_PT_BASE))
elements.property(srf_brn, "Name", "SBRN")
elements.property(srf_brn, "Description", "SBRN. srf_brn")
elements.property(srf_brn, "Colour", 0x7D4B4B)

local function funcUpdate(i,x,y,s,nt)
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		-- war
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			if chance <=30 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HRPB then
			if chance <=30 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PCOL then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PGOD then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HSED then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			if chance <=30 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			if chance <=99 then
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
			else
				sim.partChangeType(i, elem.ELEMENT_PT_SBRN)
				sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
			end
		end
	end
	local chance = math.random(2000)
	if not r and xx and yy and chance <= 1 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_SBOT)
	end
end
elements.property(srf_brn, "Update", funcUpdate)



--====================
--	   EMP
--====================

local emp = elements.allocate("ELEMENT", "ELMP")
elements.element(emp, elements.element(elements.ELEMENT_PT_BASE))
elements.property(emp, "Name", "ELMP")
elements.property(emp, "Description", "ELMP. emp")
elements.property(emp, "Colour", 0x9090FF)

local function funcUpdate(i,x,y,s,nt)
	local chance = math.random(100)
	if chance <= 5 then
		sim.partChangeType(i, elem.ELEMENT_PT_DUST)
	end
	local r, xx, yy = neighbor(x,y)
	if r then
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_TRAL then
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
			sim.partKill(i)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBOT then
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_TRAL then
			sim.partKill(i)
			sim.partChangeType(r, elem.ELEMENT_PT_ELMP)
		end
	end
	if not r and xx and yy then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_ELMP)
		sim.partKill(i)
	end
end
elements.property(emp, "Update", funcUpdate)

--====================
--	    PLAUGE
--====================

local plague = elements.allocate("ELEMENT", "PLAG")
elements.element(plague, elements.element(elements.ELEMENT_PT_BASE))
elements.property(plague, "Name", "PLAG")
elements.property(plague, "Description", "PLAG. plague")
elements.property(plague, "Colour", 0x640064)

local function funcUpdate(i,x,y,s,nt)
	local chance = math.random(100)
	if chance <= 3 then
		sim.partChangeType(i, elem.ELEMENT_PT_DUST)
	end
	local r, xx, yy = neighbor(x,y)
	if r then
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_HSED)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			sim.partChangeType(i, elem.ELEMENT_PT_HPRB)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HSED then
			sim.partChangeType(i, elem.ELEMENT_PT_PLAG)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_HCOL)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HRPB then
			sim.partChangeType(i, elem.ELEMENT_PT_HRPB)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_AST2)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_AST3)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_AST4)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PGOD then
			sim.partChangeType(i, elem.ELEMENT_PT_PLAG)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_PLAG)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_PLAG)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			sim.partChangeType(i, elem.ELEMENT_PT_PLAG)
			sim.partChangeType(r, elem.ELEMENT_PT_PLAG)
		end
	end
	if not r and xx and yy then
		sim.partKill(i)
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_PLAG)
	end
end
elements.property(plague, "Update", funcUpdate)

--====================
--	     FIRE
--====================

local fire = elements.allocate("ELEMENT", "FIRE")
elements.element(fire, elements.element(elements.ELEMENT_PT_BASE))
elements.property(fire, "Name", "FIRE")
elements.property(fire, "Description", "FIRE. fire")
elements.property(fire, "Colour", 0xFF0000)

local function funcUpdate(i,x,y,s,nt)
	local chance = math.random(100)
	if chance <= 10 then
		sim.partChangeType(i, elem.ELEMENT_PT_DUST)
	end
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST5 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST6 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST7 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST8 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTX then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		end
	end
	local chance = math.random(100)
	if not r and xx and yy and chance <= 50 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_FIR2)
		sim.partKill(i)
	elseif not r and xx and yy and chance >= 50 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_FIR3)
		sim.partKill(i)
	end
end
elements.property(fire, "Update", funcUpdate)

local fire2 = elements.allocate("ELEMENT", "FIR2")
elements.element(fire2, elements.element(elements.ELEMENT_PT_BASE))
elements.property(fire2, "Name", "FIR2")
elements.property(fire2, "Description", "FIR2. fire2")
elements.property(fire2, "Colour", 0xFFFF00)

local function funcUpdate(i,x,y,s,nt)
	local chance = math.random(100)
	if chance <= 10 then
		sim.partChangeType(i, elem.ELEMENT_PT_DUST)
	end
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HSED then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR3)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR3)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HRPB then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PGOD then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST5 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST6 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST7 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST8 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTX then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		end
	end
	local chance = math.random(100)
	if not r and xx and yy and chance <= 50 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_FIRE)
		sim.partKill(i)
	elseif not r and xx and yy and chance >= 50 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_FIR3)
		sim.partKill(i)
	end
end
elements.property(fire2, "Update", funcUpdate)

local fire3 = elements.allocate("ELEMENT", "FIR3")
elements.element(fire3, elements.element(elements.ELEMENT_PT_BASE))
elements.property(fire3, "Name", "FIR3")
elements.property(fire3, "Description", "FIR3. fire3")
elements.property(fire3, "Colour", 0xFFFFFF)

local function funcUpdate(i,x,y,s,nt)
	local chance = math.random(100)
	if chance <= 10 then
		sim.partChangeType(i, elem.ELEMENT_PT_DUST)
	end
	local r, xx, yy = neighbor(x,y)
	if r then
		local chance = math.random(100)
		if sim.partProperty(r, "type") == elem.ELEMENT_PT_HHOM then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SBRN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIRE)
			sim.partChangeType(r, elem.ELEMENT_PT_FIRE)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HPRB then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMND then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HSED then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR3)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR3)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HRPB then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_PGOD then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HBSE then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif chance <= 10 and sim.partProperty(r, "type") == elem.ELEMENT_PT_SMIN then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_HCOL then
			sim.partChangeType(i, elem.ELEMENT_PT_FIR2)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR2)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTD then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST2 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST3 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST4 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST5 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST6 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST7 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_AST8 then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		elseif sim.partProperty(r, "type") == elem.ELEMENT_PT_ASTX then
			sim.partChangeType(i, elem.ELEMENT_PT_ASTD)
			sim.partChangeType(r, elem.ELEMENT_PT_FIR3)
		end
	end
	local chance = math.random(100)
	if not r and xx and yy and chance <= 50 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_FIR2)
		sim.partKill(i)
	elseif not r and xx and yy and chance >= 50 then
		sim.partCreate(-1, xx, yy, elem.ELEMENT_PT_FIRE)
		sim.partKill(i)
	end
end
elements.property(fire3, "Update", funcUpdate)